diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/mgt-headers.cc ns-3.44/src/wifi/model/mgt-headers.cc
--- ns-3.43/src/wifi/model/mgt-headers.cc	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/mgt-headers.cc	2025-03-09 16:55:49.795372700 -0700
@@ -93,6 +93,8 @@
 uint32_t
 MgtProbeResponseHeader::GetSerializedSizeImpl() const
 {
+    SetMleContainingFrame();
+
     uint32_t size = 8 /* timestamp */ + 2 /* beacon interval */;
     size += m_capability.GetSerializedSize();
     size += WifiMgtHeader<MgtProbeResponseHeader, ProbeResponseElems>::GetSerializedSizeImpl();
@@ -102,6 +104,8 @@
 void
 MgtProbeResponseHeader::SerializeImpl(Buffer::Iterator start) const
 {
+    SetMleContainingFrame();
+
     Buffer::Iterator i = start;
     i.WriteHtolsbU64(Simulator::Now().GetMicroSeconds());
     i.WriteHtolsbU16(static_cast<uint16_t>(m_beaconInterval / 1024));
@@ -118,7 +122,20 @@
     m_beaconInterval *= 1024;
     i = m_capability.Deserialize(i);
     auto distance = i.GetDistanceFrom(start);
-    return distance + WifiMgtHeader<MgtProbeResponseHeader, ProbeResponseElems>::DeserializeImpl(i);
+    distance += WifiMgtHeader<MgtProbeResponseHeader, ProbeResponseElems>::DeserializeImpl(i);
+    if (auto& mle = Get<MultiLinkElement>())
+    {
+        for (std::size_t id = 0; id < mle->GetNPerStaProfileSubelements(); ++id)
+        {
+            auto& perStaProfile = mle->GetPerStaProfile(id);
+            if (perStaProfile.HasProbeResponse())
+            {
+                auto& frameInPerStaProfile = perStaProfile.GetProbeResponse();
+                frameInPerStaProfile.CopyIesFromContainingFrame(*this);
+            }
+        }
+    }
+    return distance;
 }
 
 /***********************************************************
@@ -270,6 +287,44 @@
                           DeserializeFromPerStaProfileImpl(i, length - distance, frame);
 }
 
+uint32_t
+MgtProbeResponseHeader::GetSerializedSizeInPerStaProfileImpl(
+    const MgtProbeResponseHeader& frame) const
+{
+    uint32_t size = 0;
+    size += m_capability.GetSerializedSize();
+    size +=
+        MgtHeaderInPerStaProfile<MgtProbeResponseHeader,
+                                 ProbeResponseElems>::GetSerializedSizeInPerStaProfileImpl(frame);
+    return size;
+}
+
+void
+MgtProbeResponseHeader::SerializeInPerStaProfileImpl(Buffer::Iterator start,
+                                                     const MgtProbeResponseHeader& frame) const
+{
+    auto i = start;
+    i = m_capability.Serialize(i);
+    MgtHeaderInPerStaProfile<MgtProbeResponseHeader,
+                             ProbeResponseElems>::SerializeInPerStaProfileImpl(i, frame);
+}
+
+uint32_t
+MgtProbeResponseHeader::DeserializeFromPerStaProfileImpl(Buffer::Iterator start,
+                                                         uint16_t length,
+                                                         const MgtProbeResponseHeader& frame)
+{
+    auto i = start;
+    m_timestamp = frame.GetTimestamp();
+    m_beaconInterval = frame.GetBeaconIntervalUs();
+    i = m_capability.Deserialize(i);
+    auto distance = i.GetDistanceFrom(start);
+    NS_ASSERT_MSG(distance <= length,
+                  "Bytes read (" << distance << ") exceed expected number (" << length << ")");
+    return distance + MgtHeaderInPerStaProfile<MgtProbeResponseHeader, ProbeResponseElems>::
+                          DeserializeFromPerStaProfileImpl(i, length - distance, frame);
+}
+
 /***********************************************************
  *          Ressoc Request
  ***********************************************************/
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/mgt-headers.h ns-3.44/src/wifi/model/mgt-headers.h
--- ns-3.43/src/wifi/model/mgt-headers.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/mgt-headers.h	2025-03-09 16:55:49.795372700 -0700
@@ -54,25 +54,25 @@
  * the STA Profile field of the Basic Multi-Link element.
  */
 
-/** \copydoc CanBeInPerStaProfile */
+/** @copydoc CanBeInPerStaProfile */
 template <>
 struct CanBeInPerStaProfile<ReducedNeighborReport> : std::false_type
 {
 };
 
-/** \copydoc CanBeInPerStaProfile */
+/** @copydoc CanBeInPerStaProfile */
 template <>
 struct CanBeInPerStaProfile<TidToLinkMapping> : std::false_type
 {
 };
 
-/** \copydoc CanBeInPerStaProfile */
+/** @copydoc CanBeInPerStaProfile */
 template <>
 struct CanBeInPerStaProfile<MultiLinkElement> : std::false_type
 {
 };
 
-/** \copydoc CanBeInPerStaProfile */
+/** @copydoc CanBeInPerStaProfile */
 template <>
 struct CanBeInPerStaProfile<Ssid> : std::false_type
 {
@@ -82,11 +82,13 @@
 using ProbeRequestElems = std::tuple<Ssid,
                                      SupportedRates,
                                      std::optional<ExtendedSupportedRatesIE>,
+                                     std::optional<DsssParameterSet>,
                                      std::optional<HtCapabilities>,
                                      std::optional<ExtendedCapabilities>,
                                      std::optional<VhtCapabilities>,
                                      std::optional<HeCapabilities>,
                                      std::optional<He6GhzBandCapabilities>,
+                                     std::optional<MultiLinkElement>,
                                      std::optional<EhtCapabilities>>;
 
 /// List of Information Elements included in Probe Response frames
@@ -143,7 +145,7 @@
                                       std::vector<TidToLinkMapping>>;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Implement the header for management frames of type association request.
  */
 class MgtAssocRequestHeader
@@ -157,45 +159,45 @@
 
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
 
-    /** \copydoc Header::GetInstanceTypeId */
+    /** @copydoc Header::GetInstanceTypeId */
     TypeId GetInstanceTypeId() const override;
 
     /**
      * Set the listen interval.
      *
-     * \param interval the listen interval
+     * @param interval the listen interval
      */
     void SetListenInterval(uint16_t interval);
     /**
      * Return the listen interval.
      *
-     * \return the listen interval
+     * @return the listen interval
      */
     uint16_t GetListenInterval() const;
     /**
-     * \return a reference to the Capability information
+     * @return a reference to the Capability information
      */
     CapabilityInformation& Capabilities();
     /**
-     * \return a const reference to the Capability information
+     * @return a const reference to the Capability information
      */
     const CapabilityInformation& Capabilities() const;
 
   protected:
-    /** \copydoc Header::GetSerializedSize */
+    /** @copydoc Header::GetSerializedSize */
     uint32_t GetSerializedSizeImpl() const;
-    /** \copydoc Header::Serialize */
+    /** @copydoc Header::Serialize */
     void SerializeImpl(Buffer::Iterator start) const;
-    /** \copydoc Header::Deserialize */
+    /** @copydoc Header::Deserialize */
     uint32_t DeserializeImpl(Buffer::Iterator start);
 
     /**
-     * \param frame the frame containing the Multi-Link Element
-     * \return the number of bytes that are needed to serialize this header into a Per-STA Profile
+     * @param frame the frame containing the Multi-Link Element
+     * @return the number of bytes that are needed to serialize this header into a Per-STA Profile
      *         subelement of the Multi-Link Element
      */
     uint32_t GetSerializedSizeInPerStaProfileImpl(const MgtAssocRequestHeader& frame) const;
@@ -203,8 +205,8 @@
     /**
      * Serialize this header into a Per-STA Profile subelement of a Multi-Link Element
      *
-     * \param start an iterator which points to where the header should be written
-     * \param frame the frame containing the Multi-Link Element
+     * @param start an iterator which points to where the header should be written
+     * @param frame the frame containing the Multi-Link Element
      */
     void SerializeInPerStaProfileImpl(Buffer::Iterator start,
                                       const MgtAssocRequestHeader& frame) const;
@@ -212,10 +214,10 @@
     /**
      * Deserialize this header from a Per-STA Profile subelement of a Multi-Link Element.
      *
-     * \param start an iterator which points to where the header should be read from
-     * \param length the expected number of bytes to read
-     * \param frame the frame containing the Multi-Link Element
-     * \return the number of bytes read
+     * @param start an iterator which points to where the header should be read from
+     * @param length the expected number of bytes to read
+     * @param frame the frame containing the Multi-Link Element
+     * @return the number of bytes read
      */
     uint32_t DeserializeFromPerStaProfileImpl(Buffer::Iterator start,
                                               uint16_t length,
@@ -227,7 +229,7 @@
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Implement the header for management frames of type reassociation request.
  */
 class MgtReassocRequestHeader
@@ -241,53 +243,53 @@
 
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
 
-    /** \copydoc Header::GetInstanceTypeId */
+    /** @copydoc Header::GetInstanceTypeId */
     TypeId GetInstanceTypeId() const override;
 
     /**
      * Set the listen interval.
      *
-     * \param interval the listen interval
+     * @param interval the listen interval
      */
     void SetListenInterval(uint16_t interval);
     /**
      * Return the listen interval.
      *
-     * \return the listen interval
+     * @return the listen interval
      */
     uint16_t GetListenInterval() const;
     /**
-     * \return a reference to the Capability information
+     * @return a reference to the Capability information
      */
     CapabilityInformation& Capabilities();
     /**
-     * \return a const reference to the Capability information
+     * @return a const reference to the Capability information
      */
     const CapabilityInformation& Capabilities() const;
     /**
      * Set the address of the current access point.
      *
-     * \param currentApAddr address of the current access point
+     * @param currentApAddr address of the current access point
      */
     void SetCurrentApAddress(Mac48Address currentApAddr);
 
   protected:
-    /** \copydoc Header::GetSerializedSize */
+    /** @copydoc Header::GetSerializedSize */
     uint32_t GetSerializedSizeImpl() const;
-    /** \copydoc Header::Serialize */
+    /** @copydoc Header::Serialize */
     void SerializeImpl(Buffer::Iterator start) const;
-    /** \copydoc Header::Deserialize */
+    /** @copydoc Header::Deserialize */
     uint32_t DeserializeImpl(Buffer::Iterator start);
-    /** \copydoc Header::Print */
+    /** @copydoc Header::Print */
     void PrintImpl(std::ostream& os) const;
 
     /**
-     * \param frame the frame containing the Multi-Link Element
-     * \return the number of bytes that are needed to serialize this header into a Per-STA Profile
+     * @param frame the frame containing the Multi-Link Element
+     * @return the number of bytes that are needed to serialize this header into a Per-STA Profile
      *         subelement of the Multi-Link Element
      */
     uint32_t GetSerializedSizeInPerStaProfileImpl(const MgtReassocRequestHeader& frame) const;
@@ -295,8 +297,8 @@
     /**
      * Serialize this header into a Per-STA Profile subelement of a Multi-Link Element
      *
-     * \param start an iterator which points to where the header should be written
-     * \param frame the frame containing the Multi-Link Element
+     * @param start an iterator which points to where the header should be written
+     * @param frame the frame containing the Multi-Link Element
      */
     void SerializeInPerStaProfileImpl(Buffer::Iterator start,
                                       const MgtReassocRequestHeader& frame) const;
@@ -304,10 +306,10 @@
     /**
      * Deserialize this header from a Per-STA Profile subelement of a Multi-Link Element.
      *
-     * \param start an iterator which points to where the header should be read from
-     * \param length the expected number of bytes to read
-     * \param frame the frame containing the Multi-Link Element
-     * \return the number of bytes read
+     * @param start an iterator which points to where the header should be read from
+     * @param length the expected number of bytes to read
+     * @param frame the frame containing the Multi-Link Element
+     * @return the number of bytes read
      */
     uint32_t DeserializeFromPerStaProfileImpl(Buffer::Iterator start,
                                               uint16_t length,
@@ -320,7 +322,7 @@
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Implement the header for management frames of type association and reassociation response.
  */
 class MgtAssocResponseHeader
@@ -334,59 +336,59 @@
 
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
 
-    /** \copydoc Header::GetInstanceTypeId */
+    /** @copydoc Header::GetInstanceTypeId */
     TypeId GetInstanceTypeId() const override;
 
     /**
      * Return the status code.
      *
-     * \return the status code
+     * @return the status code
      */
     StatusCode GetStatusCode();
     /**
      * Set the status code.
      *
-     * \param code the status code
+     * @param code the status code
      */
     void SetStatusCode(StatusCode code);
     /**
-     * \return a reference to the Capability information
+     * @return a reference to the Capability information
      */
     CapabilityInformation& Capabilities();
     /**
-     * \return a const reference to the Capability information
+     * @return a const reference to the Capability information
      */
     const CapabilityInformation& Capabilities() const;
     /**
      * Return the association ID.
      *
-     * \return the association ID
+     * @return the association ID
      */
     uint16_t GetAssociationId() const;
     /**
      * Set the association ID.
      *
-     * \param aid the association ID
+     * @param aid the association ID
      */
     void SetAssociationId(uint16_t aid);
 
   protected:
-    /** \copydoc Header::GetSerializedSize */
+    /** @copydoc Header::GetSerializedSize */
     uint32_t GetSerializedSizeImpl() const;
-    /** \copydoc Header::Serialize */
+    /** @copydoc Header::Serialize */
     void SerializeImpl(Buffer::Iterator start) const;
-    /** \copydoc Header::Deserialize */
+    /** @copydoc Header::Deserialize */
     uint32_t DeserializeImpl(Buffer::Iterator start);
-    /** \copydoc Header::Print */
+    /** @copydoc Header::Print */
     void PrintImpl(std::ostream& os) const;
 
     /**
-     * \param frame the frame containing the Multi-Link Element
-     * \return the number of bytes that are needed to serialize this header into a Per-STA Profile
+     * @param frame the frame containing the Multi-Link Element
+     * @return the number of bytes that are needed to serialize this header into a Per-STA Profile
      *         subelement of the Multi-Link Element
      */
     uint32_t GetSerializedSizeInPerStaProfileImpl(const MgtAssocResponseHeader& frame) const;
@@ -394,8 +396,8 @@
     /**
      * Serialize this header into a Per-STA Profile subelement of a Multi-Link Element
      *
-     * \param start an iterator which points to where the header should be written
-     * \param frame the frame containing the Multi-Link Element
+     * @param start an iterator which points to where the header should be written
+     * @param frame the frame containing the Multi-Link Element
      */
     void SerializeInPerStaProfileImpl(Buffer::Iterator start,
                                       const MgtAssocResponseHeader& frame) const;
@@ -403,10 +405,10 @@
     /**
      * Deserialize this header from a Per-STA Profile subelement of a Multi-Link Element.
      *
-     * \param start an iterator which points to where the header should be read from
-     * \param length the expected number of bytes to read
-     * \param frame the frame containing the Multi-Link Element
-     * \return the number of bytes read
+     * @param start an iterator which points to where the header should be read from
+     * @param length the expected number of bytes to read
+     * @param frame the frame containing the Multi-Link Element
+     * @return the number of bytes read
      */
     uint32_t DeserializeFromPerStaProfileImpl(Buffer::Iterator start,
                                               uint16_t length,
@@ -419,7 +421,7 @@
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Implement the header for management frames of type probe request.
  */
 class MgtProbeRequestHeader : public WifiMgtHeader<MgtProbeRequestHeader, ProbeRequestElems>
@@ -429,69 +431,99 @@
 
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
 
-    /** \copydoc Header::GetInstanceTypeId */
+    /** @copydoc Header::GetInstanceTypeId */
     TypeId GetInstanceTypeId() const override;
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Implement the header for management frames of type probe response.
  */
-class MgtProbeResponseHeader : public WifiMgtHeader<MgtProbeResponseHeader, ProbeResponseElems>
+class MgtProbeResponseHeader
+    : public MgtHeaderInPerStaProfile<MgtProbeResponseHeader, ProbeResponseElems>
 {
     friend class WifiMgtHeader<MgtProbeResponseHeader, ProbeResponseElems>;
+    friend class MgtHeaderInPerStaProfile<MgtProbeResponseHeader, ProbeResponseElems>;
 
   public:
     ~MgtProbeResponseHeader() override = default;
 
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
 
-    /** \copydoc Header::GetInstanceTypeId */
+    /** @copydoc Header::GetInstanceTypeId */
     TypeId GetInstanceTypeId() const override;
 
     /**
      * Return the beacon interval in microseconds unit.
      *
-     * \return beacon interval in microseconds unit
+     * @return beacon interval in microseconds unit
      */
     uint64_t GetBeaconIntervalUs() const;
     /**
      * Set the beacon interval in microseconds unit.
      *
-     * \param us beacon interval in microseconds unit
+     * @param us beacon interval in microseconds unit
      */
     void SetBeaconIntervalUs(uint64_t us);
     /**
-     * \return a reference to the Capability information
+     * @return a reference to the Capability information
      */
     CapabilityInformation& Capabilities();
     /**
-     * \return a const reference to the Capability information
+     * @return a const reference to the Capability information
      */
     const CapabilityInformation& Capabilities() const;
     /**
      * Return the time stamp.
      *
-     * \return time stamp
+     * @return time stamp
      */
     uint64_t GetTimestamp() const;
 
   protected:
-    /** \copydoc Header::GetSerializedSize */
+    /** @copydoc Header::GetSerializedSize */
     uint32_t GetSerializedSizeImpl() const;
-    /** \copydoc Header::Serialize*/
+    /** @copydoc Header::Serialize*/
     void SerializeImpl(Buffer::Iterator start) const;
-    /** \copydoc Header::Deserialize */
+    /** @copydoc Header::Deserialize */
     uint32_t DeserializeImpl(Buffer::Iterator start);
 
+    /**
+     * @param frame the frame containing the Multi-Link Element
+     * @return the number of bytes that are needed to serialize this header into a Per-STA Profile
+     *         subelement of the Multi-Link Element
+     */
+    uint32_t GetSerializedSizeInPerStaProfileImpl(const MgtProbeResponseHeader& frame) const;
+
+    /**
+     * Serialize this header into a Per-STA Profile subelement of a Multi-Link Element
+     *
+     * @param start an iterator which points to where the header should be written
+     * @param frame the frame containing the Multi-Link Element
+     */
+    void SerializeInPerStaProfileImpl(Buffer::Iterator start,
+                                      const MgtProbeResponseHeader& frame) const;
+
+    /**
+     * Deserialize this header from a Per-STA Profile subelement of a Multi-Link Element.
+     *
+     * @param start an iterator which points to where the header should be read from
+     * @param length the expected number of bytes to read
+     * @param frame the frame containing the Multi-Link Element
+     * @return the number of bytes read
+     */
+    uint32_t DeserializeFromPerStaProfileImpl(Buffer::Iterator start,
+                                              uint16_t length,
+                                              const MgtProbeResponseHeader& frame);
+
   private:
     uint64_t m_timestamp;               //!< Timestamp
     uint64_t m_beaconInterval;          //!< Beacon interval
@@ -499,7 +531,7 @@
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Implement the header for management frames of type beacon.
  */
 class MgtBeaconHeader : public MgtProbeResponseHeader
@@ -509,7 +541,7 @@
 
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/mpdu-aggregator.cc ns-3.44/src/wifi/model/mpdu-aggregator.cc
--- ns-3.43/src/wifi/model/mpdu-aggregator.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/mpdu-aggregator.cc	2025-03-09 16:55:49.795372700 -0700
@@ -10,11 +10,12 @@
 #include "mpdu-aggregator.h"
 
 #include "ampdu-subframe-header.h"
+#include "ap-wifi-mac.h"
 #include "ctrl-headers.h"
+#include "gcr-manager.h"
 #include "msdu-aggregator.h"
 #include "qos-txop.h"
 #include "wifi-mac-trailer.h"
-#include "wifi-mac.h"
 #include "wifi-mpdu.h"
 #include "wifi-net-device.h"
 #include "wifi-phy.h"
@@ -122,14 +123,19 @@
 {
     NS_LOG_FUNCTION(this << recipient << +tid << modulation);
 
-    AcIndex ac = QosUtilsMapTidToAc(tid);
+    if (auto apMac = DynamicCast<ApWifiMac>(m_mac);
+        IsGroupcast(recipient) && (m_mac->GetTypeOfStation() == AP) && apMac->GetGcrManager())
+    {
+        recipient = apMac->GetGcrManager()->GetIndividuallyAddressedRecipient(recipient);
+    }
 
+    AcIndex ac = QosUtilsMapTidToAc(tid);
     // Find the A-MPDU max size configured on this device
     uint32_t maxAmpduSize = m_mac->GetMaxAmpduSize(ac);
 
     if (maxAmpduSize == 0)
     {
-        NS_LOG_DEBUG("A-MPDU Aggregation is disabled on this station for AC " << ac);
+        NS_LOG_DEBUG("A-MPDU Aggregation is disabled on this station for " << ac);
         return 0;
     }
 
@@ -147,13 +153,14 @@
     // format used to transmit the A-MPDU
     if (modulation >= WIFI_MOD_CLASS_EHT)
     {
-        NS_ABORT_MSG_IF(!ehtCapabilities, "EHT Capabilities element not received");
+        NS_ABORT_MSG_IF(!ehtCapabilities,
+                        "EHT Capabilities element not received for " << recipient);
 
         maxAmpduSize = std::min(maxAmpduSize, ehtCapabilities->GetMaxAmpduLength());
     }
     else if (modulation >= WIFI_MOD_CLASS_HE)
     {
-        NS_ABORT_MSG_IF(!heCapabilities, "HE Capabilities element not received");
+        NS_ABORT_MSG_IF(!heCapabilities, "HE Capabilities element not received for " << recipient);
 
         maxAmpduSize = std::min(maxAmpduSize, heCapabilities->GetMaxAmpduLength());
         if (he6GhzCapabilities)
@@ -163,13 +170,14 @@
     }
     else if (modulation == WIFI_MOD_CLASS_VHT)
     {
-        NS_ABORT_MSG_IF(!vhtCapabilities, "VHT Capabilities element not received");
+        NS_ABORT_MSG_IF(!vhtCapabilities,
+                        "VHT Capabilities element not received for " << recipient);
 
         maxAmpduSize = std::min(maxAmpduSize, vhtCapabilities->GetMaxAmpduLength());
     }
     else if (modulation == WIFI_MOD_CLASS_HT)
     {
-        NS_ABORT_MSG_IF(!htCapabilities, "HT Capabilities element not received");
+        NS_ABORT_MSG_IF(!htCapabilities, "HT Capabilities element not received for " << recipient);
 
         maxAmpduSize = std::min(maxAmpduSize, htCapabilities->GetMaxAmpduLength());
     }
@@ -210,16 +218,27 @@
 
     std::vector<Ptr<WifiMpdu>> mpduList;
 
-    Mac48Address recipient = mpdu->GetHeader().GetAddr1();
-    NS_ASSERT(mpdu->GetHeader().IsQosData() && !recipient.IsBroadcast());
-    uint8_t tid = mpdu->GetHeader().GetQosTid();
-    auto origRecipient = mpdu->GetOriginal()->GetHeader().GetAddr1();
+    const auto& header = mpdu->GetHeader();
+    const auto recipient = GetIndividuallyAddressedRecipient(m_mac, header);
+    NS_ASSERT(header.IsQosData() && !recipient.IsBroadcast());
+
+    const auto& origAddr1 = mpdu->GetOriginal()->GetHeader().GetAddr1();
+    auto origRecipient = GetIndividuallyAddressedRecipient(m_mac, mpdu->GetOriginal()->GetHeader());
 
-    Ptr<QosTxop> qosTxop = m_mac->GetQosTxop(tid);
+    const auto tid = header.GetQosTid();
+    auto qosTxop = m_mac->GetQosTxop(tid);
     NS_ASSERT(qosTxop);
 
+    const auto isGcr = IsGcr(m_mac, header);
+    const auto bufferSize = qosTxop->GetBaBufferSize(origRecipient, tid, isGcr);
+    const auto startSeq = qosTxop->GetBaStartingSequence(origRecipient, tid, isGcr);
+
     // Have to make sure that the block ack agreement is established and A-MPDU is enabled
-    if (m_mac->GetBaAgreementEstablishedAsOriginator(recipient, tid) &&
+    auto apMac = DynamicCast<ApWifiMac>(m_mac);
+    const auto agreementEstablished =
+        isGcr ? apMac->IsGcrBaAgreementEstablishedWithAllMembers(header.GetAddr1(), tid)
+              : m_mac->GetBaAgreementEstablishedAsOriginator(recipient, tid).has_value();
+    if (agreementEstablished &&
         GetMaxAmpduSize(recipient, tid, txParams.m_txVector.GetModulationClass()) > 0)
     {
         /* here is performed MPDU aggregation */
@@ -227,6 +246,23 @@
 
         while (nextMpdu)
         {
+            const auto isGcrUr = isGcr && (apMac->GetGcrManager()->GetRetransmissionPolicy() ==
+                                           GroupAddressRetransmissionPolicy::GCR_UNSOLICITED_RETRY);
+            if (isGcrUr && header.IsRetry() && !nextMpdu->GetHeader().IsRetry())
+            {
+                // if this is a retransmitted A-MPDU transmitted via GCR-UR, do not add new MPDU
+                break;
+            }
+            if (isGcr &&
+                apMac->GetGcrManager()->GetRetransmissionPolicyFor(header) !=
+                    apMac->GetGcrManager()->GetRetransmissionPolicyFor(nextMpdu->GetHeader()))
+            {
+                // if an MPDU has been previously transmitted using No-Ack/No-Retry,
+                // do not add a new MPDU that still needs to be transmitted using No-Ack/No-Retry,
+                // unless No-Ack/No-Retry is the only selected retransmission policy
+                break;
+            }
+
             // if we are here, nextMpdu can be aggregated to the A-MPDU.
             NS_LOG_DEBUG("Adding packet with sequence number "
                          << nextMpdu->GetHeader().GetSequenceNumber()
@@ -237,15 +273,14 @@
 
             // If allowed by the BA agreement, get the next MPDU
             auto peekedMpdu =
-                qosTxop->PeekNextMpdu(m_linkId, tid, origRecipient, nextMpdu->GetOriginal());
+                qosTxop->PeekNextMpdu(m_linkId, tid, origAddr1, nextMpdu->GetOriginal());
             nextMpdu = nullptr;
 
             if (peekedMpdu)
             {
                 // PeekNextMpdu() does not return an MPDU that is beyond the transmit window
-                NS_ASSERT(IsInWindow(peekedMpdu->GetHeader().GetSequenceNumber(),
-                                     qosTxop->GetBaStartingSequence(origRecipient, tid),
-                                     qosTxop->GetBaBufferSize(origRecipient, tid)));
+                NS_ASSERT(
+                    IsInWindow(peekedMpdu->GetHeader().GetSequenceNumber(), startSeq, bufferSize));
 
                 peekedMpdu = m_htFem->CreateAliasIfNeeded(peekedMpdu);
                 // get the next MPDU to aggregate, provided that the constraints on size
